#include <avr/io.h>

#define FORWARD()    (PORTD = _BV(0) | _BV(2) | _BV(4) | _BV(5))
#define LEFT()       (PORTD = _BV(0) | _BV(1) | _BV(2) | _BV(4) | _BV(5))
#define RIGHT()      (PORTD = _BV(0) | _BV(2) | _BV(3) | _BV(4) | _BV(5))
#define HARD_LEFT()  (PORTD = _BV(1) | _BV(2) | _BV(4) | _BV(5))
#define HARD_RIGHT() (PORTD = _BV(0) | _BV(3) | _BV(4) | _BV(5))

#define LD_LEFT    -1
#define LD_FORWARD  0
#define LD_RIGHT    1

#define LOST       -100

int main()
{
    char v[8] = {-7, -5, -3, -1, 1, 3, 5, 7};
    char i, sum, count;

    char last_direction;
    char line_position;

    /* sensors */
    PORTA = 0xFF;
    DDRA  = 0x00;

    /* engines */
    PORTD = 0x00;
    DDRD  = 0xFF;

    last_direction = LD_FORWARD;
    for (;;) {
        /* check line position */
        sum = count = 0;
        for (i = 0; i < 8; ++i)
            if (PINA & _BV(i)) {
                sum += v[i];
                ++count;
            }
        line_position = (count == 0) ? LOST : (sum / count);

        /* lost line */
        if (line_position == LOST) {
            if (last_direction == LD_LEFT)
                HARD_LEFT();
            else if (last_direction == LD_RIGHT)
                HARD_RIGHT();
            else
                FORWARD();

        /* line left */
        } else if (line_position < -1) {
            last_direction = LD_LEFT;
            LEFT();

        /* line right */
        } else if (line_position > 1) {
            last_direction = LD_RIGHT;
            RIGHT();

        /* line centered */
        } else {
            FORWARD();
        }
    }

    return 0;
}
